<?php 
/*
 	Plugin Name: Виджеты Envybox
 	Description: Виджеты сервиса Envybox на сайт для увеличения конверсии.
 	Version: 1.1
 	Author: Envybox
 	Author URI: https://envybox.io
 	Requires at least: 5.0
	Requires PHP: 7.0
*/
/* Copyright 2025  Envybox  (email: support@envybox.io)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function envybox_register_options_page() {
   add_menu_page('Envybox', 'Envybox', 'manage_options', 'widget-add-envybox', 'widget_envybox_options_page', plugin_dir_url( __FILE__ ).'logo.png');
}
add_action('admin_menu', 'envybox_register_options_page');

function widget_envybox_options_page() {?>
	<div>
	    <h2 style="display: inline-flex;"><img style="padding: 0px 5px 0px 0px !important;" src="<? echo plugin_dir_url( __FILE__ ).'logo.png' ?>" alt="envybox.io">Envybox, виджеты на сайт</h2>
	    <?if ( isset($_POST['submit']) ) {
		   	if ( function_exists('current_user_can') && !current_user_can('manage_options') ) {
		        die();
		    }
		    if ( function_exists('check_admin_referer') ) {
		        check_admin_referer('add_envybox_form');
		    }
		    update_option('code_envybox', 
		    	serialize(
		    		[
		    			'code'=>trim($_POST['code-envybox']??''),
		    			'option'=>trim($_POST['envybox-option']??''),
		    			'deferred'=>trim($_POST['code-deferred']??'')
		    		]
		    	)
			);
		   echo  '<p 
		    			id="popup-save-envybox" 
		    			style="
		    				padding: 9px;
		    				margin-right: 20px;
		    				border: 1px solid #c3c4c7;
		    				background: white;
		    				font-weight: 600;
		    				border-left-width: 4px;
		    				border-left-color: #00a32a;
		    				box-shadow: 0 1px 1px rgba(0,0,0,.04);
		    				display: flex;
		    				justify-content: space-between;
		    			"
		    		>
		    			Настройки сохранены.
			    		<button 
			    			onclick="hide_popup_envybox()" 
			    			style="
			    				padding:0px;
			    				position: inherit;
			    			" 
			    			type="button" 
			    			class="notice-dismiss"
			    		>
			    			<span class="screen-reader-text">Скрыть это уведомление.</span>
			    		</button>
		    		</p>';
		}?>
	   <form method="post" name="add-envybox-code">
		   <? 
		      if ( function_exists('wp_nonce_field') ) {
		         wp_nonce_field('add_envybox_form'); 
		      }
		      $getBase = unserialize(get_option('code_envybox'));
			  $code = [
				'code' => $getBase['code']??'',
				'deferred' => $getBase['deferred']??'',
				'option' => $getBase['option']??''
			  ];
		   ?>
		   <p>Введите код интеграции виджетов из личного кабинета <a style="text-decoration: none;" target="_blank" href="https://envybox.io">envybox.io</a></p>
		   <table class="form-table">
	         <tbody>
		         <tr valign="top">
		            <th style="width: 110px;">
		            	<label for="code-envybox">Код интеграции:</label>
		            </th>
		            <td>
		            	<input placeholder="Введите код интеграции" style="width: 270px;text-align: center;" type="text" name="code-envybox" value="<?echo $code['code'];?>" />
		            </td>
		         </tr>
	         </tbody>   
		   </table>
		   <div style="display: inline-flex;align-items: flex-end;">
		   	<input style="margin-bottom: 2px;" type="checkbox" id="code-deferred" name="code-deferred" <?echo $code['deferred'] ? 'checked': '';?> />
    			<label for="code-deferred">Отложенная загрузка</label>
    		</div>
    		<small style="display: block;margin: 4 0 4 0;">* Виджеты будут загружены после полной загрузки страницы, не влияет на скорость работы сайта</small>
		   <div style="padding: 5px 5px 5px 0px;">
		    	<input style="margin: 0px;" type="radio" id="envybox-main" name="envybox-option" value="main" <?echo $code['deferred'] ? 'disabled': '';?> <?echo $code['option'] ? '': 'checked';?> <?echo $code['option'] == 'main' ? 'checked': '';?> />
		    	<label for="envybox-main">Стандартный код</label>
		  	</div>
		  	<small style="display: block;margin: 4 0 4 0;">* На сайте будет установлен стандартный код виджетов</small>
		  	<div style="padding: 5px 5px 5px 0px;">
		    	<input style="margin: 0px;" type="radio" id="envybox-advanced" name="envybox-option" value="advanced" <?echo $code['option'] == 'advanced' ? 'checked': '';?> />
		    	<label for="envybox-advanced">Расширенный код</label>
		  	</div>
		  	<small style="display: block;margin: 4 0 4 0;">* Включить если сайт использует кэш или не работает стандартный код</small>
		   <div style="padding: 5px 5px 5px 0px;">
		    	<input style="margin: 0px;" type="radio" id="envybox-ua" name="envybox-option" value="ua" <?echo $code['option'] == 'ua' ? 'checked': '';?> />
		    	<label for="envybox-ua">Страны с блокировкой</label>
		  	</div>
		  	<small style="display: block;margin: 4 0 4 0;">* Для стран в которых есть ограничения на загрузку сервиса</small>
			</br>
		  	<div style="display: block;margin: 20 0 4 0;font-weight: 600;">*** Произведите чистку кэша сайта в случае необходимости ***</div>
		   <?submit_button();?>
	   </form>
	</div>
	<script type="text/javascript">
		function hide_popup_envybox() {
			jQuery('body').find('#popup-save-envybox').hide();
		};
		jQuery('[name="code-deferred"]').change(function() {
		  	if (	jQuery(this).is(':checked')	) {
		  		var checked = false;
		    	jQuery('[name="envybox-option"]').each(function() {
			     	if ( jQuery(this).val() === 'main' ) {
			     		jQuery(this).prop('disabled', true);
			     	} 

			     	if ( jQuery(this).is(':checked') && jQuery(this).val() !== 'main' ){
			     		checked = true;
		    		}
			   });
			   if ( !checked ) {
			   	jQuery('body').find('#envybox-advanced').prop('checked', true);
			   };
		  	} else {
		    	jQuery('[name="envybox-option"]').each(function() {
			     	if ( jQuery(this).val() === 'main' ) {
			     		jQuery(this).prop('disabled', false);
			     	};
			   });
		  	}
		});
	</script>
<?}

function add_envybox_to_theme_head() {
	$code = unserialize(get_option('code_envybox'));
	if ( $code and $code['option'] == "main" and $code['code'] ) {
		wp_enqueue_style( 'envybox', 'https://cdn.envybox.io/widget/cbk.css', [], null, 'all' );

		add_filter( "style_loader_tag", "add_module_to_my_style", 10, 4 );
		function add_module_to_my_style( $tag, $handle, $href, $media ) 
		{
			if ( "envybox" === $handle ) {
		      $tag = "<link rel=".'stylesheet'." href=".$href.">";
		   }

		   return $tag;
		}
	}
}
add_action( 'wp_head', 'add_envybox_to_theme_head', 10 );

function add_envybox_to_theme_footer() {
	$code = unserialize(get_option('code_envybox'));

	if ( $code and $code['option'] == "main" and $code['code'] ) {
		wp_enqueue_script( 'envybox', 'https://cdn.envybox.io/widget/cbk.js?wcb_code='.$code['code'], [], null, [] );

		add_filter( "script_loader_tag", "add_module_to_my_script", 10, 3 );
		function add_module_to_my_script( $tag, $handle, $src )
		{
		   if ( "envybox" === $handle ) {
		      $tag = "<script type=\"text/javascript\" src=".$src." charset=\"UTF-8\" async></script>";
		   }

		   return $tag;
		}
	} 	elseif ( $code and $code['option'] == "advanced" and $code['code'] ) {
		wp_enqueue_script( 'envybox-code', 'https://cdn.envybox.io/widget/cbk.js?wcb_code='.$code['code'], [], null, [] );

		add_filter( "script_loader_tag", "add_module_to_my_script", 10, 3 );
		function add_module_to_my_script( $tag, $handle, $src )
		{
		    if ( "envybox-code" === $handle ) {
		    	$code = unserialize(get_option('code_envybox'));
		    	if ( $code and $code['deferred'] ) {
					$head_deffered = 'window.onload = function() {';
					$body_deffered = '};';
				} else {
					$head_deffered = '';
					$body_deffered = '';
				}

		      $tag = "<script type=\"text/javascript\">".$head_deffered."!function(){var l=document.createElement('link');l.rel='stylesheet',l.type='text/css',l.href='https://'+'cdn.env'+'ybox.io/widget/c'+'bk.css',document.head.appendChild(l);var t=document.createElement(\"script\");t.type=\"text/javascript\",t.async=!0,t.charset='UTF-8',t.src='https://cd'+'n.en'+'vybo'+'x.io/wid'+'get/cb'+'k.js?wc'+'b_code=".$code['code']."',document.body.appendChild(t);}();".$body_deffered."</script>";
		    }

		    return $tag;
		}
	}	elseif ( $code and $code['option'] == "ua" and $code['code'] ) {
		wp_enqueue_script( 'envybox-code', 'https://cdn.envybox.io/widget/cbk.js?wcb_code='.$code['code'], [], null, [] );

		add_filter(	"script_loader_tag", "add_module_to_my_script", 10, 3 );
		function add_module_to_my_script( $tag, $handle, $src )
		{
		    if ( "envybox-code" === $handle ) {
		    	$code = unserialize(get_option('code_envybox'));
		    	if ( $code and $code['deferred'] ) {
					$head_deffered = 'window.onload = function() {';
					$body_deffered = '};';
				} else {
					$head_deffered = '';
					$body_deffered = '';
				}

		      $tag = "<script type=\"text/javascript\">".$head_deffered."window.WBK_Settings={whiteSaasCode:'".$code['code']."',serverUrl:'https://u'+'a.env'+'ytools.com'};!function(){var l=document.createElement('link');l.rel='stylesheet',l.type='text/css',l.href='https://'+'cdn.env'+'ytools.com/widget/c'+'bk.css',document.head.appendChild(l);var t=document.createElement(\"script\");t.type=\"text/javascript\",t.async=!0,t.charset='UTF-8',t.src='https://'+'cdn.env'+'ytools.com/widget/c'+'bk.js',document.body.appendChild(t);}();".$body_deffered."</script>";
		    }

		    return $tag;
		}
	}
}
add_action( 'wp_footer', 'add_envybox_to_theme_footer', 10 );